/* hash.c
   symbol table routines	26 July 98

   int hash(char *s)
   void putsym(char *s, int value)
   int getsym(char *s)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LOCAL static
#define TSIZE 257	/* must be next prime double num. of sym. */

struct{
  char name[32];
  int value;
} htable[TSIZE];	/* symbol table */
int 	nsym = 0;	/* number of symbol in hash table */

LOCAL int hash( char *name ){	/* simple hash func. */
  int i, idx;
  for( idx=0, i=0; name[i] != 0; i++ )
    idx += name[i];
  return idx % TSIZE;
}

void putsym( char *name, int value){
  int idx;
  nsym++;			/* table full at TSIZE / 2 */
  if( nsym > TSIZE/2 ) {
    printf("too many symbols. increase table size\n");
    exit(0);
  }
  idx = hash(name);
  while( *htable[idx].name != 0 )
    idx = (idx + 1) % TSIZE;
  strcpy(htable[idx].name, name);
  htable[idx].value = value;
//  printf("%d putsym '%s' at %d\n",nsym,name,idx);
}

int getsym( char *name){		/* return -1 if not found */
  int idx;
  idx = hash(name);
  while( strcmp(htable[idx].name, name) != 0 ) {
    if(*htable[idx].name == 0 ) return -1;
    idx = (idx + 1) % TSIZE;
  }
  return htable[idx].value;
}

void dumpsymbol(void){     /* for debugging purpose */
  int i;
//  printf("size %d\n",nsym);
  for(i=0; i<TSIZE; i++)
    if( htable[i].name[0] != 0 )
      printf("%s %d\n",htable[i].name, htable[i].value);
}

